/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20200430 (64-bit version)
 * Copyright (c) 2000 - 2020 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of /Volumes/EFI/EFI/OC/ACPI/SSDT-TbtOnPch.aml, Wed May 13 19:12:52 2020
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x0000120D (4621)
 *     Revision         0x02
 *     Checksum         0xA1
 *     OEM ID           "dgsga "
 *     OEM Table ID     "TbtOnPCH"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20200430 (538969136)
 */
DefinitionBlock ("", "SSDT", 2, "dgsga ", "TbtOnPCH", 0x00001000)
{
    External (_GPE.XE2C, MethodObj)    // 0 Arguments
    External (_PR_.PR00, ProcessorObj)
    External (_SB_.PCI0, DeviceObj)
    External (_SB_.PCI0.GPCB, MethodObj)    // 0 Arguments
    External (_SB_.PCI0.LPCB, DeviceObj)
    External (_SB_.PCI0.RP05, DeviceObj)
    External (_SB_.PCI0.RP05.PXSX, DeviceObj)
    External (_SB_.PCI0.RP05.XINI, MethodObj)    // 0 Arguments
    External (_SB_.PCI0.SBUS, DeviceObj)
    External (MMRP, MethodObj)    // 1 Arguments
    External (TBSE, FieldUnitObj)

    Mutex (TCFG, 0x00)
    Scope (\_GPE)
    {
        Method (_E2C, 0, NotSerialized)  // _Exx: Edge-Triggered GPE, xx=0x00-0xFF
        {
            If (_OSI ("Darwin"))
            {
                \_SB.PCI0.RP05.UPSB.AMPE ()
                \_SB.PCI0.RP05.UPSB.UMPE ()
            }
            Else
            {
                XE2C ()
            }
        }
    }

    Scope (\_PR.PR00)
    {
        Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
        {
            If (!Arg2)
            {
                Return (Buffer (One)
                {
                     0x03                                             // .
                })
            }

            Return (Package (0x02)
            {
                "plugin-type", 
                One
            })
        }
    }

    Scope (\_SB)
    {
        Scope (PCI0)
        {
            Device (MCHC)
            {
                Name (_ADR, Zero)  // _ADR: Address
            }

            Device (LPCB.EC)
            {
                Name (_HID, "ACID0001")  // _HID: Hardware ID
                Method (_STA, 0, NotSerialized)  // _STA: Status
                {
                    If (_OSI ("Darwin"))
                    {
                        Return (0x0F)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }
            }

            Scope (RP05)
            {
                If (_OSI ("Darwin"))
                {
                    Name (PXSX._STA, Zero)  // _STA: Status
                }

                Name (EICM, Zero)
                Name (R020, Zero)
                Name (R024, Zero)
                Name (R028, Zero)
                Name (R02C, Zero)
                Name (R118, Zero)
                Name (R119, Zero)
                Name (R11A, Zero)
                Name (R11C, Zero)
                Name (R120, Zero)
                Name (R124, Zero)
                Name (R128, Zero)
                Name (R12C, Zero)
                Name (R218, Zero)
                Name (R219, Zero)
                Name (R21A, Zero)
                Name (R21C, Zero)
                Name (R220, Zero)
                Name (R224, Zero)
                Name (R228, Zero)
                Name (R22C, Zero)
                Name (R318, Zero)
                Name (R319, Zero)
                Name (R31A, Zero)
                Name (R31C, Zero)
                Name (R320, Zero)
                Name (R324, Zero)
                Name (R328, Zero)
                Name (R32C, Zero)
                Name (R418, Zero)
                Name (R419, Zero)
                Name (R41A, Zero)
                Name (R41C, Zero)
                Name (R420, Zero)
                Name (R424, Zero)
                Name (R428, Zero)
                Name (R42C, Zero)
                Name (RVES, Zero)
                Name (R518, Zero)
                Name (R519, Zero)
                Name (R51A, Zero)
                Name (R51C, Zero)
                Name (R520, Zero)
                Name (R524, Zero)
                Name (R528, Zero)
                Name (R52C, Zero)
                Name (R618, Zero)
                Name (R619, Zero)
                Name (R61A, Zero)
                Name (R61C, Zero)
                Name (R620, Zero)
                Name (R624, Zero)
                Name (R628, Zero)
                Name (R62C, Zero)
                Name (RH10, Zero)
                Name (RH14, Zero)
                Name (POC0, Zero)
                Method (MMBA, 1, Serialized)
                {
                    Local0 = MMRP (TBSE)
                    OperationRegion (MMMM, SystemMemory, Local0, 0x24)
                    Field (MMMM, DWordAcc, NoLock, Preserve)
                    {
                        Offset (0x19), 
                        SB19,   8, 
                        Offset (0x20), 
                        SB20,   32
                    }

                    Switch (ToInteger (Arg0))
                    {
                        Case (One)
                        {
                            Local1 = Local0
                        }
                        Case (0x02)
                        {
                            Local1 = (\_SB.PCI0.GPCB () + (SB19 * 0x00100000))
                        }
                        Case (0x03)
                        {
                            Local1 = (\_SB.PCI0.GPCB () + ((SB19 + One) * 0x00100000))
                        }
                        Case (0x04)
                        {
                            Local1 = ((\_SB.PCI0.GPCB () + ((SB19 + One) * 0x00100000)) + 
                                0x8000)
                        }
                        Case (0x05)
                        {
                            Local1 = ((\_SB.PCI0.GPCB () + ((SB19 + One) * 0x00100000)) + 
                                0x00010000)
                        }
                        Case (0x06)
                        {
                            Local1 = ((\_SB.PCI0.GPCB () + ((SB19 + One) * 0x00100000)) + 
                                0x00020000)
                        }
                        Case (0x07)
                        {
                            Local1 = (\_SB.PCI0.GPCB () + ((SB19 + 0x02) * 0x00100000))
                        }
                        Case (0x08)
                        {
                            Local1 = ((((SB20 & 0xFFFC) << 0x10) & 0xFFF00000) + 
                                0x00039854)
                        }

                    }

                    Return (Local1)
                }

                OperationRegion (RSTR, SystemMemory, MMBA (0x08), 0x0100)
                Field (RSTR, DWordAcc, NoLock, Preserve)
                {
                    CIOR,   32, 
                    Offset (0xB8), 
                    ISTA,   32, 
                    Offset (0xF0), 
                    ICME,   32
                }

                OperationRegion (RPSM, SystemMemory, MMBA (One), 0x54)
                Field (RPSM, DWordAcc, NoLock, Preserve)
                {
                    RPVD,   32, 
                    RPR4,   8, 
                    Offset (0x18), 
                    RP18,   8, 
                    RP19,   8, 
                    RP1A,   8, 
                    Offset (0x1C), 
                    RP1C,   16, 
                    Offset (0x20), 
                    R_20,   32, 
                    R_24,   32, 
                    R_28,   32, 
                    R_2C,   32, 
                    Offset (0x52), 
                        ,   11, 
                    RPLT,   1, 
                    Offset (0x54)
                }

                OperationRegion (UPSM, SystemMemory, MMBA (0x02), 0x0550)
                Field (UPSM, DWordAcc, NoLock, Preserve)
                {
                    UPVD,   32, 
                    UP04,   8, 
                    Offset (0x08), 
                    CLRD,   32, 
                    Offset (0x18), 
                    UP18,   8, 
                    UP19,   8, 
                    UP1A,   8, 
                    Offset (0x1C), 
                    UP1C,   16, 
                    Offset (0x20), 
                    UP20,   32, 
                    UP24,   32, 
                    UP28,   32, 
                    UP2C,   32, 
                    Offset (0xD2), 
                        ,   11, 
                    UPLT,   1, 
                    Offset (0xD4), 
                    Offset (0x544), 
                    UPMB,   1, 
                    Offset (0x548), 
                    T2PR,   32, 
                    P2TR,   32
                }

                OperationRegion (DNSM, SystemMemory, MMBA (0x03), 0xD4)
                Field (DNSM, DWordAcc, NoLock, Preserve)
                {
                    DPVD,   32, 
                    DP04,   8, 
                    Offset (0x18), 
                    DP18,   8, 
                    DP19,   8, 
                    DP1A,   8, 
                    Offset (0x1C), 
                    DP1C,   16, 
                    Offset (0x20), 
                    DP20,   32, 
                    DP24,   32, 
                    DP28,   32, 
                    DP2C,   32, 
                    Offset (0xD2), 
                        ,   11, 
                    DPLT,   1, 
                    Offset (0xD4)
                }

                OperationRegion (DS3M, SystemMemory, MMBA (0x04), 0x40)
                Field (DS3M, DWordAcc, NoLock, Preserve)
                {
                    D3VD,   32, 
                    D304,   8, 
                    Offset (0x18), 
                    D318,   8, 
                    D319,   8, 
                    D31A,   8, 
                    Offset (0x1C), 
                    D31C,   16, 
                    Offset (0x20), 
                    D320,   32, 
                    D324,   32, 
                    D328,   32, 
                    D32C,   32
                }

                OperationRegion (DS4M, SystemMemory, MMBA (0x05), 0x0568)
                Field (DS4M, DWordAcc, NoLock, Preserve)
                {
                    D4VD,   32, 
                    D404,   8, 
                    Offset (0x18), 
                    D418,   8, 
                    D419,   8, 
                    D41A,   8, 
                    Offset (0x1C), 
                    D41C,   16, 
                    Offset (0x20), 
                    D420,   32, 
                    D424,   32, 
                    D428,   32, 
                    D42C,   32, 
                    Offset (0x564), 
                    DVES,   32
                }

                OperationRegion (DS5M, SystemMemory, MMBA (0x06), 0x40)
                Field (DS5M, DWordAcc, NoLock, Preserve)
                {
                    D5VD,   32, 
                    D504,   8, 
                    Offset (0x18), 
                    D518,   8, 
                    D519,   8, 
                    D51A,   8, 
                    Offset (0x1C), 
                    D51C,   16, 
                    Offset (0x20), 
                    D520,   32, 
                    D524,   32, 
                    D528,   32, 
                    D52C,   32
                }

                OperationRegion (NHIM, SystemMemory, MMBA (0x07), 0x40)
                Field (NHIM, DWordAcc, NoLock, Preserve)
                {
                    NH00,   32, 
                    NH04,   8, 
                    Offset (0x10), 
                    NH10,   32, 
                    NH14,   32
                }

                Method (_INI, 0, NotSerialized)  // _INI: Initialize
                {
                    If (_OSI ("Darwin"))
                    {
                        Acquire (TCFG, 0xFFFF)
                        R020 = R_20 /* \_SB_.PCI0.RP05.R_20 */
                        R024 = R_24 /* \_SB_.PCI0.RP05.R_24 */
                        R118 = RP19 /* \_SB_.PCI0.RP05.RP19 */
                        R119 = (RP19 + One)
                        R11A = RP1A /* \_SB_.PCI0.RP05.RP1A */
                        R11C = RP1C /* \_SB_.PCI0.RP05.RP1C */
                        R120 = R_20 /* \_SB_.PCI0.RP05.R_20 */
                        R124 = R_24 /* \_SB_.PCI0.RP05.R_24 */
                        R218 = R119 /* \_SB_.PCI0.RP05.R119 */
                        R219 = (R119 + One)
                        R21A = R11A /* \_SB_.PCI0.RP05.R11A */
                        R21C = R11C /* \_SB_.PCI0.RP05.R11C */
                        R220 = R120 /* \_SB_.PCI0.RP05.R120 */
                        R224 = R124 /* \_SB_.PCI0.RP05.R124 */
                        R318 = R119 /* \_SB_.PCI0.RP05.R119 */
                        R319 = (R119 + 0x02)
                        R31A = (R119 + 0x02)
                        R31C = Zero
                        R320 = Zero
                        R324 = Zero
                        R418 = R119 /* \_SB_.PCI0.RP05.R119 */
                        R419 = (R119 + 0x03)
                        R41A = (R119 + 0x03)
                        R41C = Zero
                        R420 = Zero
                        R424 = Zero
                        RVES = Zero
                        R518 = R119 /* \_SB_.PCI0.RP05.R119 */
                        R519 = (R119 + 0x04)
                        R51A = (R119 + 0x04)
                        R51C = Zero
                        R520 = Zero
                        R524 = Zero
                        R618 = Zero
                        R619 = Zero
                        R61A = Zero
                        R61C = Zero
                        R620 = Zero
                        R624 = Zero
                        RH10 = ((R220 & 0xFFFC) << 0x10)
                        RH14 = Zero
                        Sleep (One)
                        ICMS ()
                        Release (TCFG)
                    }
                    Else
                    {
                        XINI ()
                    }
                }

                Method (ICMS, 0, NotSerialized)
                {
                    \_SB.PCI0.RP05.POC0 = One
                    If ((\_SB.PCI0.RP05.ICME != 0x800001A3))
                    {
                        If (\_SB.PCI0.RP05.CNHI ())
                        {
                            If ((\_SB.PCI0.RP05.ICME != 0xFFFFFFFF))
                            {
                                \_SB.PCI0.RP05.WTLT ()
                                \_SB.PCI0.RP05.ICME |= 0x06
                                Local0 = 0x03E8
                                While (((\_SB.PCI0.RP05.ICME & 0x80000000) == Zero))
                                {
                                    Local0--
                                    If ((Local0 == Zero))
                                    {
                                        Break
                                    }

                                    Sleep (One)
                                }

                                Sleep (0x03E8)
                            }
                        }
                    }

                    \_SB.PCI0.RP05.POC0 = Zero
                }

                Method (CNHI, 0, Serialized)
                {
                    Local0 = 0x0A
                    While (Local0)
                    {
                        R_20 = R020 /* \_SB_.PCI0.RP05.R020 */
                        R_24 = R024 /* \_SB_.PCI0.RP05.R024 */
                        R_28 = R028 /* \_SB_.PCI0.RP05.R028 */
                        R_2C = R02C /* \_SB_.PCI0.RP05.R02C */
                        RPR4 = 0x07
                        If ((R020 == R_20))
                        {
                            Break
                        }

                        Sleep (One)
                        Local0--
                    }

                    If ((R020 != R_20))
                    {
                        Return (Zero)
                    }

                    Local0 = 0x0A
                    While (Local0)
                    {
                        UP18 = R118 /* \_SB_.PCI0.RP05.R118 */
                        UP19 = R119 /* \_SB_.PCI0.RP05.R119 */
                        UP1A = R11A /* \_SB_.PCI0.RP05.R11A */
                        UP1C = R11C /* \_SB_.PCI0.RP05.R11C */
                        UP20 = R120 /* \_SB_.PCI0.RP05.R120 */
                        UP24 = R124 /* \_SB_.PCI0.RP05.R124 */
                        UP28 = R128 /* \_SB_.PCI0.RP05.R128 */
                        UP2C = R12C /* \_SB_.PCI0.RP05.R12C */
                        UP04 = 0x07
                        If ((R119 == UP19))
                        {
                            Break
                        }

                        Sleep (One)
                        Local0--
                    }

                    If ((R119 != UP19))
                    {
                        Return (Zero)
                    }

                    If ((WTLT () == One)){}
                    Else
                    {
                        Return (Zero)
                    }

                    Local0 = 0x0A
                    While (Local0)
                    {
                        DP18 = R218 /* \_SB_.PCI0.RP05.R218 */
                        DP19 = R219 /* \_SB_.PCI0.RP05.R219 */
                        DP1A = R21A /* \_SB_.PCI0.RP05.R21A */
                        DP1C = R21C /* \_SB_.PCI0.RP05.R21C */
                        DP20 = R220 /* \_SB_.PCI0.RP05.R220 */
                        DP24 = R224 /* \_SB_.PCI0.RP05.R224 */
                        DP28 = R228 /* \_SB_.PCI0.RP05.R228 */
                        DP2C = R22C /* \_SB_.PCI0.RP05.R22C */
                        DP04 = 0x07
                        D318 = R318 /* \_SB_.PCI0.RP05.R318 */
                        D319 = R319 /* \_SB_.PCI0.RP05.R319 */
                        D31A = R31A /* \_SB_.PCI0.RP05.R31A */
                        D31C = R31C /* \_SB_.PCI0.RP05.R31C */
                        D320 = R320 /* \_SB_.PCI0.RP05.R320 */
                        D324 = R324 /* \_SB_.PCI0.RP05.R324 */
                        D328 = R328 /* \_SB_.PCI0.RP05.R328 */
                        D32C = R32C /* \_SB_.PCI0.RP05.R32C */
                        D304 = 0x07
                        D418 = R418 /* \_SB_.PCI0.RP05.R418 */
                        D419 = R419 /* \_SB_.PCI0.RP05.R419 */
                        D41A = R41A /* \_SB_.PCI0.RP05.R41A */
                        D41C = R41C /* \_SB_.PCI0.RP05.R41C */
                        D420 = R420 /* \_SB_.PCI0.RP05.R420 */
                        D424 = R424 /* \_SB_.PCI0.RP05.R424 */
                        D428 = R428 /* \_SB_.PCI0.RP05.R428 */
                        D42C = R42C /* \_SB_.PCI0.RP05.R42C */
                        DVES = RVES /* \_SB_.PCI0.RP05.RVES */
                        D404 = 0x07
                        D518 = R518 /* \_SB_.PCI0.RP05.R518 */
                        D519 = R519 /* \_SB_.PCI0.RP05.R519 */
                        D51A = R51A /* \_SB_.PCI0.RP05.R51A */
                        D51C = R51C /* \_SB_.PCI0.RP05.R51C */
                        D520 = R520 /* \_SB_.PCI0.RP05.R520 */
                        D524 = R524 /* \_SB_.PCI0.RP05.R524 */
                        D528 = R528 /* \_SB_.PCI0.RP05.R528 */
                        D52C = R52C /* \_SB_.PCI0.RP05.R52C */
                        D504 = 0x07
                        If ((R219 == DP19))
                        {
                            Break
                        }

                        Sleep (One)
                        Local0--
                    }

                    If ((R219 != DP19))
                    {
                        Return (Zero)
                    }

                    If ((WTDL () != One))
                    {
                        Return (Zero)
                    }

                    Local0 = 0x64
                    While (Local0)
                    {
                        NH10 = RH10 /* \_SB_.PCI0.RP05.RH10 */
                        NH14 = RH14 /* \_SB_.PCI0.RP05.RH14 */
                        NH04 = 0x07
                        If ((RH10 == NH10))
                        {
                            Break
                        }
                        Else
                        {
                        }

                        Sleep (One)
                        Local0--
                    }

                    If ((RH10 != NH10))
                    {
                        Return (Zero)
                    }

                    Return (One)
                }

                Method (UPCK, 0, Serialized)
                {
                    If (((UPVD & 0xFF00FFFF) == 0x15008086))
                    {
                        Return (One)
                    }
                    Else
                    {
                        Return (Zero)
                    }
                }

                Method (ULTC, 0, Serialized)
                {
                    If ((RPLT == Zero))
                    {
                        If ((UPLT == Zero))
                        {
                            Return (One)
                        }
                    }

                    Return (Zero)
                }

                Method (WTLT, 0, Serialized)
                {
                    Local0 = 0x07D0
                    Local1 = Zero
                    While (Local0)
                    {
                        If ((RPR4 == 0x07))
                        {
                            If (ULTC ())
                            {
                                If (UPCK ())
                                {
                                    Local1 = One
                                    Break
                                }
                            }
                        }

                        Sleep (One)
                        Local0--
                    }

                    Return (Local1)
                }

                Method (DLTC, 0, Serialized)
                {
                    If ((RPLT == Zero))
                    {
                        If ((UPLT == Zero))
                        {
                            If ((DPLT == Zero))
                            {
                                Return (One)
                            }
                        }
                    }

                    Return (Zero)
                }

                Method (WTDL, 0, Serialized)
                {
                    Local0 = 0x07D0
                    Local1 = Zero
                    While (Local0)
                    {
                        If ((RPR4 == 0x07))
                        {
                            If (DLTC ())
                            {
                                If (UPCK ())
                                {
                                    Local1 = One
                                    Break
                                }
                            }
                        }

                        Sleep (One)
                        Local0--
                    }

                    Return (Local1)
                }

                Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                {
                    Return (Zero)
                }

                Device (UPSB)
                {
                    Name (_ADR, Zero)  // _ADR: Address
                    Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                    {
                        Return (Zero)
                    }

                    Method (AMPE, 0, Serialized)
                    {
                        Notify (\_SB.PCI0.RP05.UPSB.DSB0.NHI0, Zero) // Bus Check
                    }

                    Method (UMPE, 0, Serialized)
                    {
                        Notify (\_SB.PCI0.RP05.UPSB.DSB2.XHC2, Zero) // Bus Check
                    }

                    Device (DSB0)
                    {
                        Name (_ADR, Zero)  // _ADR: Address
                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            Return (Zero)
                        }

                        Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
                        {
                            If (_OSI ("Darwin"))
                            {
                                If ((Arg0 == ToUUID ("a0b5b7c6-1318-441c-b0c9-fe695eaf949b")))
                                {
                                    If (!Arg2)
                                    {
                                        Return (Buffer (One)
                                        {
                                             0x03                                             // .
                                        })
                                    }

                                    Return (Package (0x02)
                                    {
                                        "PCIHotplugCapable", 
                                        Zero
                                    })
                                }
                            }

                            Return (Zero)
                        }

                        Device (NHI0)
                        {
                            Name (_ADR, Zero)  // _ADR: Address
                            Name (_STR, Unicode ("Thunderbolt"))  // _STR: Description String
                            Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                            {
                                Return (Zero)
                            }

                            Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
                            {
                                If (_OSI ("Darwin"))
                                {
                                    If (!Arg2)
                                    {
                                        Return (Buffer (One)
                                        {
                                             0x03                                             // .
                                        })
                                    }

                                    Return (Package (0x03)
                                    {
                                        "power-save", 
                                        One, 
                                        Buffer (One)
                                        {
                                             0x00                                             // .
                                        }
                                    })
                                }

                                Return (Zero)
                            }
                        }
                    }

                    Device (DSB1)
                    {
                        Name (_ADR, 0x00010000)  // _ADR: Address
                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            Return (Zero)
                        }
                    }

                    Device (DSB2)
                    {
                        Name (_ADR, 0x00020000)  // _ADR: Address
                        Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
                        {
                            Return (Zero)
                        }

                        Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
                        {
                            If (_OSI ("Darwin"))
                            {
                                If ((Arg0 == ToUUID ("a0b5b7c6-1318-441c-b0c9-fe695eaf949b")))
                                {
                                    If (!Arg2)
                                    {
                                        Return (Buffer (One)
                                        {
                                             0x03                                             // .
                                        })
                                    }

                                    Return (Package (0x02)
                                    {
                                        "PCIHotplugCapable", 
                                        Zero
                                    })
                                }
                            }

                            Return (Zero)
                        }

                        Device (XHC2)
                        {
                            Name (_ADR, Zero)  // _ADR: Address
                            Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
                            {
                                If (!Arg2)
                                {
                                    Return (Buffer (One)
                                    {
                                         0x03                                             // .
                                    })
                                }

                                Return (Package (0x04)
                                {
                                    "USBBusNumber", 
                                    Zero, 
                                    "AAPL,xhci-clock-id", 
                                    One
                                })
                            }

                            Name (HS, Package (0x01)
                            {
                                "XHC2"
                            })
                            Name (FS, Package (0x01)
                            {
                                "XHC2"
                            })
                            Name (LS, Package (0x01)
                            {
                                "XHC2"
                            })
                            Device (RHUB)
                            {
                                Name (_ADR, Zero)  // _ADR: Address
                                Device (HS01)
                                {
                                    Name (_ADR, One)  // _ADR: Address
                                    Name (_UPC, Package (0x04)  // _UPC: USB Port Capabilities
                                    {
                                        0xFF, 
                                        0x09, 
                                        Zero, 
                                        Zero
                                    })
                                    Name (_PLD, Package (0x01)  // _PLD: Physical Location of Device
                                    {
                                        ToPLD (
                                            PLD_Revision           = 0x1,
                                            PLD_IgnoreColor        = 0x1,
                                            PLD_Red                = 0x0,
                                            PLD_Green              = 0x0,
                                            PLD_Blue               = 0x0,
                                            PLD_Width              = 0x0,
                                            PLD_Height             = 0x0,
                                            PLD_UserVisible        = 0x1,
                                            PLD_Dock               = 0x0,
                                            PLD_Lid                = 0x0,
                                            PLD_Panel              = "UNKNOWN",
                                            PLD_VerticalPosition   = "UPPER",
                                            PLD_HorizontalPosition = "LEFT",
                                            PLD_Shape              = "UNKNOWN",
                                            PLD_GroupOrientation   = 0x0,
                                            PLD_GroupToken         = 0x0,
                                            PLD_GroupPosition      = 0x0,
                                            PLD_Bay                = 0x0,
                                            PLD_Ejectable          = 0x0,
                                            PLD_EjectRequired      = 0x0,
                                            PLD_CabinetNumber      = 0x0,
                                            PLD_CardCageNumber     = 0x0,
                                            PLD_Reference          = 0x0,
                                            PLD_Rotation           = 0x0,
                                            PLD_Order              = 0x0,
                                            PLD_VerticalOffset     = 0x0,
                                            PLD_HorizontalOffset   = 0x0)

                                    })
                                    Name (SSP, Package (0x02)
                                    {
                                        "XHC2", 
                                        0x03
                                    })
                                    Name (SS, Package (0x02)
                                    {
                                        "XHC2", 
                                        0x03
                                    })
                                    Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
                                    {
                                        If (!Arg2)
                                        {
                                            Return (Buffer (One)
                                            {
                                                 0x03                                             // .
                                            })
                                        }

                                        Return (Package (0x04)
                                        {
                                            "kUSBWakePortCurrentLimit", 
                                            0x0BB8, 
                                            "kUSBSleepPortCurrentLimit", 
                                            0x0BB8
                                        })
                                    }
                                }

                                Device (SSP1)
                                {
                                    Name (_ADR, 0x03)  // _ADR: Address
                                    Name (_UPC, Package (0x04)  // _UPC: USB Port Capabilities
                                    {
                                        0xFF, 
                                        0x09, 
                                        Zero, 
                                        Zero
                                    })
                                    Name (_PLD, Package (0x01)  // _PLD: Physical Location of Device
                                    {
                                        ToPLD (
                                            PLD_Revision           = 0x1,
                                            PLD_IgnoreColor        = 0x1,
                                            PLD_Red                = 0x0,
                                            PLD_Green              = 0x0,
                                            PLD_Blue               = 0x0,
                                            PLD_Width              = 0x0,
                                            PLD_Height             = 0x0,
                                            PLD_UserVisible        = 0x1,
                                            PLD_Dock               = 0x0,
                                            PLD_Lid                = 0x0,
                                            PLD_Panel              = "UNKNOWN",
                                            PLD_VerticalPosition   = "UPPER",
                                            PLD_HorizontalPosition = "LEFT",
                                            PLD_Shape              = "UNKNOWN",
                                            PLD_GroupOrientation   = 0x0,
                                            PLD_GroupToken         = 0x0,
                                            PLD_GroupPosition      = 0x0,
                                            PLD_Bay                = 0x0,
                                            PLD_Ejectable          = 0x0,
                                            PLD_EjectRequired      = 0x0,
                                            PLD_CabinetNumber      = 0x0,
                                            PLD_CardCageNumber     = 0x0,
                                            PLD_Reference          = 0x0,
                                            PLD_Rotation           = 0x0,
                                            PLD_Order              = 0x0,
                                            PLD_VerticalOffset     = 0x0,
                                            PLD_HorizontalOffset   = 0x0)

                                    })
                                    Name (FS, Package (0x02)
                                    {
                                        "XHC2", 
                                        One
                                    })
                                    Name (LS, Package (0x02)
                                    {
                                        "XHC2", 
                                        One
                                    })
                                    Name (HS, Package (0x02)
                                    {
                                        "XHC2", 
                                        One
                                    })
                                    Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
                                    {
                                        If (!Arg2)
                                        {
                                            Return (Buffer (One)
                                            {
                                                 0x03                                             // .
                                            })
                                        }

                                        Return (Package (0x08)
                                        {
                                            "UsbCPortNumber", 
                                            0x02, 
                                            "UsbPowerSource", 
                                            0x02, 
                                            "kUSBWakePortCurrentLimit", 
                                            0x0BB8, 
                                            "kUSBSleepPortCurrentLimit", 
                                            0x0BB8
                                        })
                                    }
                                }
                            }
                        }
                    }

                    Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
                    {
                        If ((Arg0 == ToUUID ("a0b5b7c6-1318-441c-b0c9-fe695eaf949b")))
                        {
                            If (!Arg2)
                            {
                                Return (Buffer (One)
                                {
                                     0x03                                             // .
                                })
                            }

                            Return (Package (0x02)
                            {
                                "PCI-Thunderbolt", 
                                One
                            })
                        }

                        Return (Zero)
                    }
                }
            }

            Device (SBUS.BUS0)
            {
                Name (_CID, "smbus")  // _CID: Compatible ID
                Name (_ADR, Zero)  // _ADR: Address
                Device (BLC0)
                {
                    Name (_ADR, Zero)  // _ADR: Address
                    Name (_CID, "smbus-blc")  // _CID: Compatible ID
                    Name (_STA, 0x0F)  // _STA: Status
                    Name (_GPE, 0x52)  // _GPE: General Purpose Events
                }
            }

            Device (SBUS.BUS1)
            {
                Name (_CID, "smbus")  // _CID: Compatible ID
                Name (_ADR, One)  // _ADR: Address
            }
        }

        Device (USBX)
        {
            Name (_ADR, Zero)  // _ADR: Address
            Method (_DSM, 4, NotSerialized)  // _DSM: Device-Specific Method
            {
                If (!Arg2)
                {
                    Return (Buffer (One)
                    {
                         0x03                                             // .
                    })
                }

                Return (Package (0x08)
                {
                    "kUSBSleepPowerSupply", 
                    0x13EC, 
                    "kUSBSleepPortCurrentLimit", 
                    0x0834, 
                    "kUSBWakePowerSupply", 
                    0x13EC, 
                    "kUSBWakePortCurrentLimit", 
                    0x0834
                })
            }
        }
    }
}

